import serial
import pygame
import time

pygame.init()

ser = serial.Serial('/dev/tty.usbmodem1421', 9600)
print(ser.name)

songIndex = 0
songKeys = [0, 0, 7, 7, 9, 9, 7, 5, 5, 4, 4, 2, 2, 0, 7, 7, 5, 5, 4, 4, 2, 7, 7, 5, 5, 4, 4, 2, 0, 0, 7, 7, 9, 9, 7, 5, 5, 4, 4, 2, 2, 0]
songFingers = []

currentNote = songKeys.pop(0)
# cn = bytes([currentNote])

# time.sleep(1)
# for i in range(8):
# 	byteNum = ser.write("\x01".encode())
# 	print("Sent " + str(byteNum) + " Bytes")

while True:
	inputLine = ser.readline()
	if (inputLine):
		#print(inputLine[0] + " " + inputLine[1])
		
		# print("Current Note: " + str(currentNote))
		# print("Input: " + str(inputLine))
		# print()
		if (len(inputLine) >= 5):
			print(inputLine)

		if (len(inputLine) >= 2 and len(inputLine) < 5):
			note = inputLine[0]
		
			correct = True
			if (len(songKeys) is not 0):
				if note == currentNote:
					correct = True
					print("Correct Note Played!")
				else:
					correct = False

			if (correct):
				if (len(songKeys) == 0):
					nextKey = 0
					#nextKey = bytes([255])
					#ser.write(chr(255).encode())
				else:
					currentNote = songKeys.pop(0)
					#nextKey = bytes([currentNote])
					#ser.write(chr(currentNote).encode())

				volume = inputLine[1] / 255.0
				volume = volume ** 2

				sound = pygame.mixer.Sound("./notes/c1.wav")
				if (note == 0):
					sound = pygame.mixer.Sound('./notes/c1.wav')
				if (note == 1):
					sound = pygame.mixer.Sound('./notes/c1s.wav')
				if (note == 2):
					sound = pygame.mixer.Sound('./notes/d1.wav')
				if (note == 3):
					sound = pygame.mixer.Sound('./notes/d1s.wav')
				if (note == 4):
					sound = pygame.mixer.Sound('./notes/e1.wav')
				if (note == 5):
					sound = pygame.mixer.Sound('./notes/f1.wav')
				if (note == 6):
					sound = pygame.mixer.Sound('./notes/f1s.wav')
				if (note == 7):
					sound = pygame.mixer.Sound('./notes/g1.wav')
				if (note == 8):
					sound = pygame.mixer.Sound('./notes/g1s.wav')
				if (note == 9):
					sound = pygame.mixer.Sound('./notes/a1.wav')
				if (note == 10):
					sound = pygame.mixer.Sound('./notes/a1s.wav')
				if (note == 11):
					sound = pygame.mixer.Sound('./notes/b1.wav')
				
				sound.set_volume(volume)
				sound.play()
			else:
				print("Incorrect Note Played")